unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,  httpsend, ext_fun, inifiles, mmsystem;

type
  TThreadLogin = class(TThread)
  protected
    procedure Execute; override;
  end;


var
  LoginTh: TThreadLogin;
 cook: string;


type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Edit3: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Edit4: TEdit;
    Label4: TLabel;
    ListBox1: TListBox;
    Label5: TLabel;
    Edit5: TEdit;
    Label6: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit4Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}






procedure TThreadLogin.Execute;
var
  temp, temp2, temp3: string;
  HTTP: THTTPSend;
  URLData, cook: string;
  i, count: integer;

  Label end_, start_;



  function login:bool;
  begin
    result:=false;
    cook:='';

    URLData  := 'login='+form1.edit1.Text+'&password='+form1.edit2.Text+'&submitted=%D0%92%D0%BE%D0%B9%D1%82%D0%B8';
    try

      HTTP.Clear;
      HTTP.Document.Write(Pointer(URLData)^, Length(URLData));
      HTTP.MimeType := 'application/x-www-form-urlencoded';

      if not HTTP.HTTPMethod('POST', 'http://wap.mamba.ru/?area=login')
      then begin
        form1.Memo1.Lines.Add(' !') ;
        exit;
      end;

      cook:= HTTP.Cookies.Text;
      temp:= HTTP.Headers.Text;

      HTTP.Document.SaveToFile('logs\login-1_[docum].html');
      HTTP.Headers.SaveToFile('logs\login-1_[head].html');


      if (pos('302', temp) or pos('200', temp))>0
      then begin
        form1.Memo1.Lines.Add(' - ok') ;
      end else begin
        form1.Memo1.Lines.Add(' - !') ;
        exit;
      end;

      result:=true;
    except
      form1.Memo1.Lines.Add('  !') ;
    end;
  end;



begin

  HTTP:= THTTPSend.Create;
  try
        repeat
         sleep(5000);    //     
        until login;

    repeat




      start_:


      HTTP.Cookies.Text:=cook;
      HTTP.Headers.Add('Referer: http://wap.mamba.ru/?area=login');
      
        if not HTTP.HTTPMethod('GET', 'http://wap.mamba.ru/')
          then begin
            form1.Memo1.Lines.Add(' !') ;
            goto  end_;
          end;

        temp:= UTF8toansi(StreamToString(HTTP.Document));
        HTTP.Document.SaveToFile('logs\index_[docum].html');
        HTTP.Headers.SaveToFile('logs\index_[head].html');
        cook:= HTTP.Cookies.Text;


        if pos('  ', temp)>0
        then begin
          Form1.Edit3.Text:='0';
          form1.Memo1.Lines.Add('   - ok');
        end else begin
          temp2:=get(temp, 'msg-quantity">[', '&nbsp;');
          if temp2='?' then begin
            form1.Memo1.Lines.Add('   - c,  ') ;
            login;
            goto start_;
          end else begin
            form1.Memo1.Lines.Add('   - ok');
            Form1.Edit3.Text:=temp2;
          end;
        end;








        // 
        HTTP.Headers.Clear;
        HTTP.Headers.Add('Referer: http://wap.mamba.ru/?area=login');

        if not HTTP.HTTPMethod('GET', 'http://wap.mamba.ru/?area=showFolder&folderId=294658&onlyOnline=1')
          then begin
           form1.Memo1.Lines.Add(' !') ;
           goto end_;
          end;

        temp:= UTF8toansi(StreamToString(HTTP.Document));
        HTTP.Document.SaveToFile('logs\online_[docum].html');
        HTTP.Headers.SaveToFile('logs\online_[head].html');
        cook:= HTTP.Cookies.Text;

        if pos(' ', temp)>0
          then begin
            form1.Memo1.Lines.Add('  - ok.') ;
          end else begin
            form1.Memo1.Lines.Add('  - c,  ') ;
            login;
            goto start_;
          end;

        Form1.ListBox1.Clear;
        if pos('C .', temp)>0    //    
          then  begin
            Form1.ListBox1.Items.Add('<     >')  ;
            form1.Edit5.Text:='0';
          end else begin                    //    -
            i:=0;
            count:=strtoint(get(temp, '  (', ')') );
            form1.Edit5.Text:=inttostr(count);
            repeat              //       

              inc(i);
              temp2:= get_int(temp, '<td class="txt-container">', '</td>', i);
              temp3:= get(temp2, '#ff6633">', '&nbsp;');  // - 
              temp2 := get_int(temp2, '">', '</a>', 1);   // 

              if temp3='?'
                then temp3:=temp2
                else temp3:=temp2+' ['+temp3+']';

              Form1.ListBox1.Items.Add(temp3) ;

            until i=count;
          end;

         end_:
        sleep(strtoint(Form1.edit4.text)*1000);



      until false;  //  


    finally
      HTTP.Free;
      form1.button1.Enabled:=true;
    end;
    

end;



procedure TForm1.Button1Click(Sender: TObject);
begin
  LoginTH := TThreadLogin.Create(False);
  Button1.Enabled:=false;
end;


procedure TForm1.Edit3Change(Sender: TObject);
begin
  try
    if Form1.Edit3.Text='?' then exit;
    if strtoint(Form1.Edit3.Text)>0 then
    begin
   //   Form1.Edit3.color:=clLime;
      sndPlaySound('1.WAV', SND_ASYNC);
      Form2.Show;

    end else  Form1.Edit3.color:=clWindow;
  except
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  configini: TIniFile;
begin

  if not directoryexists(ExtractFilePath(Application.ExeName)+'logs\') then
    mkdir(ExtractFilePath(Application.ExeName)+'logs\');

  configini := TIniFile.Create(ExtractFilePath(Application.ExeName)+'config.ini');
  edit1.Text:= configini.ReadString('General', 'Login', '');
  Edit2.Text:= configini.ReadString('General', 'Pass', '');
  Edit4.Text:= configini.ReadString('General', 'Time', '15');

  configini.Free;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  configini: TIniFile;
begin

  configini := TIniFile.Create(ExtractFilePath(Application.ExeName)+'config.ini');
  configini.WriteString('General', 'Login', Edit1.Text);
  configini.WriteString('General', 'Pass', Edit2.Text);
  configini.WriteString('General', 'Time', Edit4.Text);
  configini.Free;

end;

procedure TForm1.Edit4Change(Sender: TObject);
begin
  try
    strtoint(edit4.text)
  except
    edit4.text:='15';
  end;
end;

end.
